Index: tests/.expect/PRNG.x64.txt
===================================================================
--- tests/.expect/PRNG.x64.txt	(revision ae7a085c8585b48815059235b608cbf4791dd8e5)
+++ tests/.expect/PRNG.x64.txt	(revision 814a4da00637a1b6596dfdc58790e9773bfd45da)
@@ -1,96 +1,96 @@
 
                     PRNG()     PRNG(5)   PRNG(0,5)
-                8464106481           4           4
-       5215204710507639537           1           2
-       1880401021892145483           0           4
-      12503840966285181348           2           5
-        801971300205459356           0           2
-       6123812066052045228           3           1
-       7691074772031490538           4           3
-       4793575011534070065           0           0
-      10647551928893428440           1           3
-      10865128702974868079           0           3
-        530720947131684825           3           0
-      10520125295812061287           1           5
-       7539957561855178679           4           4
-      13739826796006269835           0           2
-       4289714351582916365           3           2
-      16911914987551424434           2           1
-       5327155553462670435           4           0
-      16251986870929071204           4           4
-      13394433706240223001           0           3
-       4814982023332666924           4           0
+       2629641414891406278           3           0
+      11972157801652581900           3           5
+       9470682093934978437           2           2
+        316134424938305673           2           2
+       5572275127081588144           0           3
+      12394954141290188855           2           2
+      15386440704589550620           2           1
+       5760167266331356361           2           5
+       8021670258373873290           2           5
+       8813161879342109574           1           4
+      10525294799876107814           2           0
+      14801827301969351008           3           0
+      17016612914230924215           0           0
+       5485205801221744751           3           2
+       6143666691223938511           4           0
+      15086131934315954459           4           5
+       4547668615176940328           4           5
+      17718351571399359777           0           5
+       2636252641646208341           4           0
+      12820158953704882599           0           4
 seed 1009
 
 Sequential
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
 
 Concurrent
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
 
                     prng()     prng(5)   prng(0,5)
-                8464106481           4           4
-       5215204710507639537           1           2
-       1880401021892145483           0           4
-      12503840966285181348           2           5
-        801971300205459356           0           2
-       6123812066052045228           3           1
-       7691074772031490538           4           3
-       4793575011534070065           0           0
-      10647551928893428440           1           3
-      10865128702974868079           0           3
-        530720947131684825           3           0
-      10520125295812061287           1           5
-       7539957561855178679           4           4
-      13739826796006269835           0           2
-       4289714351582916365           3           2
-      16911914987551424434           2           1
-       5327155553462670435           4           0
-      16251986870929071204           4           4
-      13394433706240223001           0           3
-       4814982023332666924           4           0
+       2629641414891406278           3           0
+      11972157801652581900           3           5
+       9470682093934978437           2           2
+        316134424938305673           2           2
+       5572275127081588144           0           3
+      12394954141290188855           2           2
+      15386440704589550620           2           1
+       5760167266331356361           2           5
+       8021670258373873290           2           5
+       8813161879342109574           1           4
+      10525294799876107814           2           0
+      14801827301969351008           3           0
+      17016612914230924215           0           0
+       5485205801221744751           3           2
+       6143666691223938511           4           0
+      15086131934315954459           4           5
+       4547668615176940328           4           5
+      17718351571399359777           0           5
+       2636252641646208341           4           0
+      12820158953704882599           0           4
 seed 1009
 
 Sequential
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
 
 Concurrent
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
 
                    prng(t)   prng(t,5) prng(t,0,5)
-                8464106481           4           4
-       5215204710507639537           1           2
-       1880401021892145483           0           4
-      12503840966285181348           2           5
-        801971300205459356           0           2
-       6123812066052045228           3           1
-       7691074772031490538           4           3
-       4793575011534070065           0           0
-      10647551928893428440           1           3
-      10865128702974868079           0           3
-        530720947131684825           3           0
-      10520125295812061287           1           5
-       7539957561855178679           4           4
-      13739826796006269835           0           2
-       4289714351582916365           3           2
-      16911914987551424434           2           1
-       5327155553462670435           4           0
-      16251986870929071204           4           4
-      13394433706240223001           0           3
-       4814982023332666924           4           0
+       2629641414891406278           3           0
+      11972157801652581900           3           5
+       9470682093934978437           2           2
+        316134424938305673           2           2
+       5572275127081588144           0           3
+      12394954141290188855           2           2
+      15386440704589550620           2           1
+       5760167266331356361           2           5
+       8021670258373873290           2           5
+       8813161879342109574           1           4
+      10525294799876107814           2           0
+      14801827301969351008           3           0
+      17016612914230924215           0           0
+       5485205801221744751           3           2
+       6143666691223938511           4           0
+      15086131934315954459           4           5
+       4547668615176940328           4           5
+      17718351571399359777           0           5
+       2636252641646208341           4           0
+      12820158953704882599           0           4
 seed 1009
 
 Sequential
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
 
 Concurrent
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
-trials 100000000 buckets 100000 min 871 max 1144 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%
+trials 100000000 buckets 100000 min 875 max 1146 avg 1000.0 std 31.6 rstd 3.2%